<?php

//////////
///
///   target.inc.php
///
//////////

require_once('lib/commons.inc.php');



/*************\
*   METHODS   *
\*************/

$dm['target.add']         = array('func'   => 'target_add',
                                  'perm'   => AL_ADMN,
                                  'escape' => true);

$dm['target.mod']         = array('func'   => 'target_mod',
                                  'perm'   => AL_ADMN,
                                  'escape' => true);

$dm['target.del']         = array('func'   => 'target_del',
                                  'perm'   => AL_ADMN,
                                  'escape' => true);

$dm['target.get']         = array('func'   => 'target_get',
                                  'perm'   => AL_ADMN | AL_TECH | AL_VIEW,
                                  'escape' => true);

$dm['target.getbackdoor'] = array('func'   => 'target_getbackdoor',
                                  'perm'   => AL_ADMN | AL_TECH | AL_VIEW,
                                  'escape' => true);

$dm['target.stat']        = array('func'   => 'target_stat',
                                  'perm'   => AL_VIEW,
                                  'escape' => true);


/***************\
*   FUNCTIONS   *
\***************/

function target_add($target, $desc, $activity_id)
{
   // XXX va fatto in modo che ritornino tutti i campi appena creati

   $em[1062] = array('target', 'exists');

   $sql  = "SELECT `status` ";
   $sql .= "FROM `activity` ";
   $sql .= "WHERE `activity_id` = '$activity_id'";

   $ret = db_query($sql);

   if(!is_success($ret)) {
      return $ret;
   } else if($ret['payload'] === false) {
      return error('target', 'nosuchactivity');
   }

   if($ret['payload'][0]->status == 'CLOSED') {
      return error('target', 'noperm');
   }

   $sql  = "INSERT INTO `target` (`target`, ";
   $sql .=                       "`desc`, ";
   $sql .=                       "`activity_id`) ";
   $sql .= "VALUES ('$target', ";
   $sql .=         "'$desc', ";
   $sql .=         "'$activity_id')";

   $ret = db_query($sql, $em);

   if(!is_success($ret)) {
      return $ret;
   }

   $sql = "SELECT LAST_INSERT_ID() AS `target_id`";

   $ret = db_query($sql);

   if(!is_success($ret)) {
      return $ret;
   }

   setaccess($_SESSION['authuserid']);

   trace('target.add', "target=$target({$ret['payload'][0]->target_id})", 0, 0, $activity_id, $ret['payload'][0]->target_id, 0);

   return success((integer)$ret['payload'][0]->target_id);
}

function target_mod($target_id, $target, $desc)
{
   $em[1062] = array('target', 'exists');

   $sql  = "SELECT `activity`.`activity_id` AS `activity_id`, ";
   $sql  =        "`activity`.`status` AS `status`";
   $sql .= "FROM `activity` ";
   $sql .= "JOIN `target` ";
   $sql .= "USING (`activity_id`) ";
   $sql .= "WHERE `target_id` = '$target_id'";

   $ret = db_query($sql);

   if(!is_success($ret)) {
      return $ret;
   } else if($ret['payload'] === false) {
      return error('target', 'nosuchtarget');
   }

   if($ret['payload'][0]->status == 'CLOSED') {
      return error('target', 'noperm');
   }

   $activity_id = $ret['payload'][0]->activity_id;

   trace('target.mod', "target_id=$target_id", 0, 0, $activity_id, $target_id, 0);

   $sql  = "UPDATE `target` ";
   $sql .= "SET `target` = '$target', ";
   $sql .=     "`desc` = '$desc' ";
   $sql .= "WHERE `target_id` = '$target_id'";

   return db_query($sql, $em);
}

function target_del($target_id)
{
   $sql  = "SELECT `activity`.`activity_id` AS `activity_id`, ";
   $sql  =        "`activity`.`status` AS `status`";
   $sql .= "FROM `activity` ";
   $sql .= "JOIN `target` ";
   $sql .= "USING (`activity_id`) ";
   $sql .= "WHERE `target_id` = '$target_id'";

   $ret = db_query($sql);

   if(!is_success($ret)) {
      return $ret;
   } else if($ret['payload'] === false) {
      return error('target', 'nosuchtarget');
   }

   if($ret['payload'][0]->status == 'CLOSED') {
      return error('target', 'noperm');
   }

   $activity_id = $ret['payload'][0]->activity_id;

   $sql  = "DELETE FROM `target` ";
   $sql .= "WHERE `target_id` = '$target_id'";

   $ret = db_query($sql);

   setaccess($_SESSION['authuserid']);

   trace('target.del', "target_id=$target_id", 0, 0, $activity_id, $target_id, 0);

   return $ret;
}

function target_get($target_id)
{
   $sql  = "SELECT `target_id`, ";
   $sql .=        "`target`, ";
   $sql .=        "`desc`, ";
   $sql .=        "`activity_id` ";
   $sql .= "FROM `target` ";
   $sql .= "WHERE 1";
   $sql .= ($target_id ? " AND `target_id` = '$target_id'" : '');
   $sql .= (($_SESSION['authlevel'] & AL_ADMN) ? '' : " AND `target_id` IN ('".implode("', '", $_SESSION['authtargetid'])."')");

   $ret = db_query($sql);

   if(!is_success($ret)) {
      return $ret;
   } else if($ret['payload'] === false) {
      return success(array());
   }

   return $ret;
}

function target_getbackdoor($target_id)
{
   $sql  = "SELECT `backdoor_id`, ";
   $sql .=        "`backdoor`, ";
   $sql .=        "`desc`, ";
   $sql .=        "`version` ";
   $sql .= "FROM `backdoor` ";
   $sql .= "WHERE `target_id` = '$target_id'";
   $sql .= (($_SESSION['authlevel'] & AL_ADMN) ? '' : " AND `target_id` IN ('".implode("', '", $_SESSION['authtargetid'])."')");

   $ret = db_query($sql);

   if(!is_success($ret)) {
      return $ret;
   } else if($ret['payload'] === false) {
      return success(array());
   }

   return $ret;
}

function target_stat($target_id)
{
   $sql  = "SELECT `stat`.*, `backdoor`.`target_id`, `target`.`activity_id` ";
   $sql .= "FROM `stat` ";
   $sql .= "JOIN `backdoor` ";
   $sql .= "USING (`backdoor_id`) ";
   $sql .= "JOIN `target` ";
   $sql .= "USING (`target_id`) ";
   $sql .= "WHERE `target_id` IN ('".implode("', '", $_SESSION['authtargetid'])."') ";
   $sql .= (count($target_id) ? "AND `target_id` IN ('".implode("', '", $target_id)."') " : '');
   $sql .= "ORDER BY `stat`.`received` DESC";

   $ret = db_query($sql);

   if(!is_success($ret)) {
      return $ret;
   } else if($ret['payload'] === false) {
      return success(array());
   }

   return $ret;
}

?>
