<?php

//////////
///
///   upload.inc.php
///
//////////

require_once('lib/commons.inc.php');


/*************\
*   METHODS   *
\*************/

$dm['upload.add']        = array('func'   => 'upload_add',
                                 'perm'   => AL_TECH,
                                 'escape' => false);

$dm['upload.del']        = array('func'   => 'upload_del',
                                 'perm'   => AL_SERV | AL_TECH,
                                 'escape' => true);

$dm['upload.get']        = array('func'   => 'upload_get',
                                 'perm'   => AL_SERV | AL_TECH,
                                 'escape' => true);



/***************\
*   FUNCTIONS   *
\***************/

function upload_add($backdoor_id, $filename, $contentfile)
{
   if(!in_array($backdoor_id, $_SESSION['authbackdoorid'])) {
      return error('upload', 'nosuchbackdoor');
   }

   if(!(isset($contentfile) && isset($_SESSION['upload'][$contentfile]))) {
      return error('session', 'nosuchupload');
   }

   $sql  = "SELECT `activity`.`activity_id` AS `activity_id`, ";
   $sql .=        "`activity`.`status` AS `status`, ";
   $sql .=        "`target`.`target_id` AS `target_id` ";
   $sql .= "FROM `activity` ";
   $sql .= "JOIN `target` ";
   $sql .= "USING (`activity_id`) ";
   $sql .= "JOIN `backdoor` ";
   $sql .= "USING (`target_id`) ";
   $sql .= "WHERE `backdoor_id` = '$backdoor_id'";

   $ret = db_query($sql);

   if(!is_success($ret)) {
      return $ret;
   } else if($ret['payload'] === false) {
      return error('upload', 'nosuchbackdoor');
   }

   if($ret['payload'][0]->status == 'CLOSED') {
      return error('upload', 'noperm');
   }

   $activity_id = $ret['payload'][0]->activity_id;
   $target_id = $ret['payload'][0]->target_id;

   $sql  = "INSERT INTO `upload` (`backdoor_id`, ";
   $sql .=                       "`filename`, ";
   $sql .=                       "`content`) ";
   $sql .= "VALUES ('$backdoor_id', '$filename', ?)";

   $ret = db_prepare($sql);

   if(!is_success($ret)) {
      return $ret;
   }

   $stmt = $ret['payload'];

   $params = array(array('t' => 'b', 'v' => sys_get_temp_dir().'/'.$contentfile));

   $ret = db_execute($stmt, $params);

   unlink(sys_get_temp_dir().'/'.$contentfile);
   unset($_SESSION['upload'][$contentfile]);

   if(!is_success($ret)) {
      return $ret;
   }

   $sql = "SELECT LAST_INSERT_ID() AS `upload_id`";

   $ret = db_query($sql);

   if(!is_success($ret)) {
      return $ret;
   }

   trace('upload.add', "upload_id={$ret['payload'][0]->upload_id}", 0, 0, $activity_id, $target_id, $backdoor_id);

   return success((integer)$ret['payload'][0]->upload_id);
}

function upload_del($upload_id)
{
   trace('upload.del', "upload_id=$upload_id", 0, 0, 0, 0, 0);

   $sql  = "DELETE FROM `upload` ";
   $sql .= "WHERE `upload_id` = '$upload_id'";
   $sql .= (($_SESSION['authlevel'] & AL_SERV) ? '' : " AND `backdoor_id` IN ('".implode("', '", $_SESSION['authbackdoorid'])."') ");

   return db_query($sql);
}

function upload_get($backdoor_id)
{
   if(!($_SESSION['authlevel'] & AL_SERV) && !in_array($backdoor_id, $_SESSION['authbackdoorid'])) {
      return error('upload', 'nosuchbackdoor');
   }

   $sql  = "SELECT `upload_id`, ";
   $sql .=        "`filename` ";
   $sql .= "FROM `upload` ";
   $sql .= "WHERE `backdoor_id` = '$backdoor_id'";

   $ret = db_query($sql);

   if(!is_success($ret)) {
      return $ret;
   } else if($ret['payload'] === false) {
      return success(array());
   }

   return $ret;
}

?>
