<?php

//////////
///
///   server.php
///
//////////

require_once('lib/commons.inc.php');



/*************\
*   METHODS   *
\*************/

require_once('methods/activity.inc.php');
require_once('methods/assign.inc.php');
require_once('methods/auth.inc.php');
require_once('methods/backdoor.inc.php');
require_once('methods/blotter.inc.php');
require_once('methods/cert.inc.php');
require_once('methods/config.inc.php');
require_once('methods/core.inc.php');
require_once('methods/download.inc.php');
require_once('methods/group.inc.php');
require_once('methods/log.inc.php');
require_once('methods/member.inc.php');
require_once('methods/monitor.inc.php');
require_once('methods/note.inc.php');
require_once('methods/sign.inc.php');
require_once('methods/target.inc.php');
require_once('methods/trace.inc.php');
require_once('methods/upload.inc.php');
require_once('methods/user.inc.php');



/***************\
*   FUNCTIONS   *
\***************/

function methodhandler($method, $params)
{
   global $authuser, $authuserid;

   error_log("$method(begin): user=$authuser($authuserid)");

   if(file_exists('debug')) {
      error_log("$method(debug): user=$authuser($authuserid), params=".strtr(print_r($params, true), "\n", ' '));
   }

   if(($GLOBALS['dm'][$method]['escape'])) {
      db_escape($params);
   }

   $ret = checklimits();

   if(is_success($ret)) {
      $ret = call_user_func_array($GLOBALS['dm'][$method]['func'], $params);
   }

   $authuser = (isset($_SESSION['authuser']) ? $_SESSION['authuser'] : '');
   $authuserid = (isset($_SESSION['authuserid']) ? $_SESSION['authuserid'] : '');

   if(!is_success($ret)) {
      error_log("$method(error): user=$authuser($authuserid), ".
                                "error=\"{$ret['payload']['faultString']}\"({$ret['payload']['faultCode']})");
   } else if(file_exists('debug')) {
      error_log("$method(debug): user=$authuser($authuserid), ret=".strtr(print_r($ret['payload'], true), "\n", ' '));
   }

   error_log("$method(ended): user=$authuser($authuserid)");

   return $ret['payload'];
}


/**********\
*   MAIN   *
\**********/

$authuser = (isset($_SESSION['authuser']) ? $_SESSION['authuser'] : '');
$authuserid = (isset($_SESSION['authuserid']) ? $_SESSION['authuserid'] : 'none');

$output_opt = array('encoding'  => 'UTF-8',
                    'verbosity' => 'no_white_space',
                    'escaping'  => 'markup');

$s = xmlrpc_server_create();

foreach(array_keys($dm) as $m) {
   if(!isset($_SESSION['authlevel']) && ($dm[$m]['perm'] != AL_NONE)) {
      continue;
   } else if(isset($_SESSION['authlevel']) && !($dm[$m]['perm'] & $_SESSION['authlevel'])) {
      continue;
   }

   xmlrpc_server_register_method($s, $m, 'methodhandler');
}

$ret = xmlrpc_server_call_method($s, $HTTP_RAW_POST_DATA, false, $output_opt);
xmlrpc_server_destroy($s);

if(stripos($ret, '<member><name>faultCode</name><value><int>-32601</int></value></member>') !== false) {
   if(preg_match('{<member><name>faultString</name><value><string>.*?[\n]+(?P<err>[^<]*)</string></value></member>}', $ret, $matches)) {
      error_log("{$matches['err']}(begin): user=$authuser($authuserid)");
      error_log("{$matches['err']}(error): user=$authuser($authuserid), ".
                                          'error="Method not found"');
      error_log("{$matches['err']}(ended): user=$authuser($authuserid)");
   }
}

/*
 *** questo serve per sistemare il problema dei tag vuoti usati dalla libreria XMLRPC di ASP e HCM
*/
if(isset($_SERVER['HTTP_USER_AGENT']) && ($_SERVER['HTTP_USER_AGENT'] == 'XMLRPC++ 0.7')) {
   $ret = preg_replace('{<([[:alpha:]]+)/>}', '<$1></$1>', $ret);
}

header('Content-Length: '.strlen($ret));
header('Content-Type: text/xml; charset=UTF-8');

echo $ret;

?>
